function y = NewBarrier(Spot,Bar,T,v,M1,M2)

% Returns the modified barrier depending on the monitoring frequency.
% M1 = 0 means we monitor Hourly, Daily, Weekly, or Monthly.
% M1 > 0 means we monitor continously, based on M1 observations.

if Bar > Spot
    Sign = 1;
else
    Sign = -1;
end

switch M1
	case 0
		% Monitoring at discrete time intervals.
        switch M2
            case 'H'
				Bar = Bar*exp(Sign*0.5826*v*sqrt(1/24/364));
            case 'D'
				Bar = Bar*exp(Sign*0.5826*v*sqrt(1/364));
            case 'W'
				Bar = Bar*exp(Sign*0.5826*v*sqrt(1/52));
            case 'M'
				Bar = Bar*exp(Sign*0.5826*v*sqrt(1/12));
		end
	otherwise
		% Continuous monitoring.
        Bar = Bar*exp(Sign*0.5826*v*sqrt(T/M1));
end

y = Bar;
